"{ Package: 'stx:libjava/experiments' }"

Object variableByteSubclass:#StHashSet
	instanceVariableNames:'map'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests'
!


!StHashSet class methodsFor:'accessing'!

javaObject
    ^ JavaObjectDictionary new reflectionOf: self name

    "Created: / 09-01-2011 / 21:02:37 / Jan Kurs <kurs.jan@post.cz>"
! !

!StHashSet methodsFor:'accessing'!

javaObject
    ^ self class javaObject.
"/    javaObject ifNil: [
"/        javaObject:= Java classForName: 'Counter'.
"/    ].
"/    ^ javaObject.

    "Created: / 09-01-2011 / 13:56:56 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 21:02:18 / Jan Kurs <kurs.jan@post.cz>"
! !

!StHashSet methodsFor:'error handling'!

doesNotUnderstand:aMessage 
    | method |
    aMessage selector = #'__map()Ljava/util/HashMap;' ifTrue:[ ^ self getMap].
    aMessage selector = #'__map(Ljava/util/HashMap;)V' ifTrue:[ ^ self setMap: aMessage arguments first.].

    method := JavaClass 
                lookupMethod:aMessage selector
                numArgs:aMessage arguments size
                in:self javaObject
                static:false.

    ^ method 
        ifNil:[ super doesNotUnderstand:aMessage.]
        ifNotNil:[ method valueWithReceiver:self arguments:aMessage arguments.]

    "Created: / 09-01-2011 / 13:42:08 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 15:54:04 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 24-01-2011 / 16:20:15 / kursjan <kursjan@fit.cvut.cz>"
! !

!StHashSet methodsFor:'java protocol'!

getMap
    map isNil ifTrue: [
        map := (Java classForName:'java.util.HashMap') new.
    ].

    ^ map.

    "Created: / 24-01-2011 / 16:21:45 / kursjan <kursjan@fit.cvut.cz>"
!

setMap: aMap
    map := aMap.

    "Created: / 24-01-2011 / 16:22:34 / kursjan <kursjan@fit.cvut.cz>"
! !

!StHashSet methodsFor:'testing'!

isKindOf: aClass
    "This override is neccessary for ST <-> Java Object conversions"
    (self javaObject includesBehavior: aClass) ifTrue:
    [
        ^ true.
    ].
    ^ super isKindOf: aClass.

    "Created: / 09-01-2011 / 13:28:10 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 21:22:41 / Jan Kurs <kurs.jan@post.cz>"
! !

!StHashSet class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !